<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: field/hexternal.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_00a13ab5e3afe633796d5c180ae90994.html">field</a>
  </div>
</div>
<div class="contents">
<h1>hexternal.c</h1><a href="hexternal_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: hexternal.c 3001 2010-03-15 15:22:36Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="field_8h.html">field.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util/util.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span><span class="preprocessor">#include &quot;addons/addons.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#endif</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span>
<a name="l00034"></a>00034 <span class="preprocessor">#ifdef SPINTORQ</span>
<a name="l00035"></a>00035 <span class="preprocessor"></span><span class="preprocessor">#include &quot;spintorq/spintorq.h&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#endif</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span>
<a name="l00038"></a>00038 <span class="keyword">static</span> <span class="keywordtype">int</span> doinit=1;
<a name="l00039"></a>00039 <span class="keyword">static</span> Vec VHextsum=PETSC_NULL;
<a name="l00040"></a>00040 <span class="keyword">static</span> PetscReal hextsum=0;
<a name="l00041"></a>00041 
<a name="l00042"></a><a class="code" href="hexternal_8c.html#a3459c1707cc058f462cb730e78809f17">00042</a> <span class="keywordtype">int</span> <a class="code" href="hexternal_8c.html#a3459c1707cc058f462cb730e78809f17">Hexternal_Init</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00045"></a>00045 
<a name="l00046"></a>00046   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Hexternal on\n&quot;</span>);
<a name="l00047"></a>00047 
<a name="l00048"></a>00048   ierr = VecDuplicate(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;VHextsum);CHKERRQ(ierr);
<a name="l00049"></a>00049   ierr = VecDuplicate(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;gdata-&gt;<a class="code" href="structGridData.html#a9fdfeb31eb70dd07c65f5717feddcdbf">VHext</a>);CHKERRQ(ierr);
<a name="l00050"></a>00050 
<a name="l00051"></a>00051   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00052"></a>00052 }
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a><a class="code" href="hexternal_8c.html#aeaf153862ea87b88e30bee559bf1d481">00055</a> <span class="keywordtype">int</span> <a class="code" href="field_8h.html#aeaf153862ea87b88e30bee559bf1d481">Hexternal</a>(<a class="code" href="structGridData.html">GridData</a> *gdata,Vec VHtotsum)
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00058"></a>00058 
<a name="l00059"></a>00059   <span class="comment">/* initialize if necessary */</span>
<a name="l00060"></a>00060   <span class="keywordflow">if</span> (doinit) {
<a name="l00061"></a>00061     ierr = <a class="code" href="hexternal_8c.html#a3459c1707cc058f462cb730e78809f17">Hexternal_Init</a>(gdata);CHKERRQ(ierr);
<a name="l00062"></a>00062     doinit=0;
<a name="l00063"></a>00063   }
<a name="l00064"></a>00064 
<a name="l00065"></a>00065   hextsum=0;
<a name="l00066"></a>00066   ierr = VecZeroEntries(VHextsum);CHKERRQ(ierr);
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   PetscReal hext;
<a name="l00069"></a>00069   hext=0;ierr = <a class="code" href="field_8h.html#aeb00096e7649b4910f8fa67dc6f27401">Hext_ho</a>(gdata,VHextsum,&amp;hext);CHKERRQ(ierr); hextsum += hext;
<a name="l00070"></a>00070   hext=0;ierr = <a class="code" href="field_8h.html#a30cb382d2ba1eb8b00264cf43ce43e05">Hext_kq</a>(gdata,VHextsum,&amp;hext);CHKERRQ(ierr); hextsum += hext;
<a name="l00071"></a>00071   hext=0;ierr = <a class="code" href="field_8h.html#a2866a2d9dd35b17789e06b1b79ab72cc">Hext_cu</a>(gdata,VHextsum,&amp;hext);CHKERRQ(ierr); hextsum += hext;
<a name="l00072"></a>00072   hext=0;ierr = <a class="code" href="field_8h.html#a66aec7a3ca42c0059d2b330ca937a555">Hext_py</a>(gdata,VHextsum,&amp;hext);CHKERRQ(ierr); hextsum += hext;
<a name="l00073"></a>00073 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00074"></a>00074 <span class="preprocessor"></span>  hext=0;ierr = Hext_ac(gdata,VHextsum,&amp;hext);CHKERRQ(ierr); hextsum += hext;
<a name="l00075"></a>00075   hext=0;ierr = Hext_co(gdata,VHextsum,&amp;hext);CHKERRQ(ierr); hextsum += hext;
<a name="l00076"></a>00076   hext=0;ierr = Hext_do(gdata,VHextsum,&amp;hext);CHKERRQ(ierr); hextsum += hext;
<a name="l00077"></a>00077   hext=0;ierr = Hext_ht1(gdata,VHextsum,&amp;hext);CHKERRQ(ierr);hextsum += hext;
<a name="l00078"></a>00078   hext=0;ierr = Hext_ht2(gdata,VHextsum,&amp;hext);CHKERRQ(ierr);hextsum += hext;
<a name="l00079"></a>00079   hext=0;ierr = Hext_mp(gdata,VHextsum,&amp;hext);CHKERRQ(ierr); hextsum += hext;
<a name="l00080"></a>00080   hext=0;ierr = Hext_pd(gdata,VHextsum,&amp;hext);CHKERRQ(ierr); hextsum += hext;
<a name="l00081"></a>00081   hext=0;ierr = Hext_rg(gdata,VHextsum,&amp;hext);CHKERRQ(ierr); hextsum += hext;
<a name="l00082"></a>00082   hext=0;ierr = Hext_tf(gdata,VHextsum,&amp;hext);CHKERRQ(ierr); hextsum += hext;
<a name="l00083"></a>00083 <span class="preprocessor">#endif</span>
<a name="l00084"></a>00084 <span class="preprocessor"></span><span class="preprocessor">#ifdef SPINTORQ</span>
<a name="l00085"></a>00085 <span class="preprocessor"></span>  hext=0;ierr = Hcurrent(gdata,VHextsum,&amp;hext);CHKERRQ(ierr);hextsum += hext;
<a name="l00086"></a>00086   hext=0;ierr = Hcurrent_stack(gdata,VHextsum,&amp;hext);CHKERRQ(ierr);hextsum += hext;
<a name="l00087"></a>00087 <span class="preprocessor">#endif</span>
<a name="l00088"></a>00088 <span class="preprocessor"></span>
<a name="l00089"></a>00089   <span class="comment">/* copy total field into VHext */</span>
<a name="l00090"></a>00090   ierr = VecCopy(VHextsum,gdata-&gt;<a class="code" href="structGridData.html#a9fdfeb31eb70dd07c65f5717feddcdbf">VHext</a>);CHKERRQ(ierr);
<a name="l00091"></a>00091 
<a name="l00092"></a>00092   ierr = VecAXPY(VHtotsum,1,VHextsum);CHKERRQ(ierr);
<a name="l00093"></a>00093 
<a name="l00094"></a>00094   <a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">MagparFunctionProfReturn</a>(0);
<a name="l00095"></a>00095 }
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00098"></a><a class="code" href="hexternal_8c.html#abab705ab0b3df8ea71709f470033aee2">00098</a> <span class="keywordtype">int</span> <a class="code" href="field_8h.html#abab705ab0b3df8ea71709f470033aee2">Hexternal_Energy</a>(<a class="code" href="structGridData.html">GridData</a> *gdata,Vec VMom,PetscReal *energy)
<a name="l00099"></a>00099 {
<a name="l00100"></a>00100   PetscReal e;
<a name="l00101"></a>00101 
<a name="l00102"></a>00102   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   ierr = VecDot(VMom,VHextsum,&amp;e);CHKERRQ(ierr);
<a name="l00105"></a>00105   e *= -1.0;
<a name="l00106"></a>00106 
<a name="l00107"></a>00107   *energy=e;
<a name="l00108"></a>00108 
<a name="l00109"></a>00109   <a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">MagparFunctionProfReturn</a>(0);
<a name="l00110"></a>00110 }
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 
<a name="l00113"></a><a class="code" href="hexternal_8c.html#a48d0086e7ff33076be493f9379c45069">00113</a> PetscReal <a class="code" href="field_8h.html#a48d0086e7ff33076be493f9379c45069">Hexternal_hext</a>()
<a name="l00114"></a>00114 {
<a name="l00115"></a>00115   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00116"></a>00116   <a class="code" href="griddata_8h.html#a3a0efa409c6998ac8e9d7b30da6a8171">MagparFunctionInfoReturn</a>(hextsum);
<a name="l00117"></a>00117 }
<a name="l00118"></a>00118 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

